"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DVCClient = void 0;
var Variable_1 = require("./Variable");
var Request_1 = require("./Request");
var Store_1 = __importDefault(require("./Store"));
var User_1 = require("./User");
var EventQueue_1 = require("./EventQueue");
var utils_1 = require("./utils");
var EventEmitter_1 = require("./EventEmitter");
var types_1 = require("@devcycle/types");
var ConfigRequestConsolidator_1 = require("./ConfigRequestConsolidator");
var logger_1 = require("./logger");
var StreamingConnection_1 = require("./StreamingConnection");
var DVCClient = /** @class */ (function () {
    function DVCClient(environmentKey, user, options) {
        if (options === void 0) { options = {}; }
        var _this = this;
        this.userSaved = false;
        this._closing = false;
        this.user = new User_1.DVCPopulatedUser(user, options);
        this.options = options;
        this.environmentKey = environmentKey;
        this.variableDefaultMap = {};
        this.eventQueue = new EventQueue_1.EventQueue(environmentKey, this, options === null || options === void 0 ? void 0 : options.eventFlushIntervalMS);
        this.requestConsolidator = new ConfigRequestConsolidator_1.ConfigRequestConsolidator(function (user, extraParams) { return (0, Request_1.getConfigJson)(_this.environmentKey, user, _this.logger, _this.options, extraParams); }, function (config, user) { return _this.handleConfigReceived(config, user); }, this.user);
        this.eventEmitter = new EventEmitter_1.EventEmitter();
        this.logger = options.logger || (0, logger_1.dvcDefaultLogger)({ level: options.logLevel });
        this.store = new Store_1.default(typeof window !== 'undefined' ? window.localStorage : stubbedLocalStorage, this.logger);
        this.registerVisibilityChangeHandler();
        this.onInitialized = this.requestConsolidator.queue(this.user)
            .then(function () {
            var _a, _b;
            _this.eventEmitter.emitInitialized(true);
            if ((_b = (_a = _this.config) === null || _a === void 0 ? void 0 : _a.sse) === null || _b === void 0 ? void 0 : _b.url) {
                _this.streamingConnection = new StreamingConnection_1.StreamingConnection(_this.config.sse.url, _this.onSSEMessage.bind(_this), _this.logger);
            }
            return _this;
        })
            .catch(function (err) {
            _this.eventEmitter.emitInitialized(false);
            _this.eventEmitter.emitError(err);
            return _this;
        });
        if (!(options === null || options === void 0 ? void 0 : options.reactNative) && typeof window !== 'undefined') {
            this.windowMessageHandler = function (event) {
                var message = event.data;
                if ((message === null || message === void 0 ? void 0 : message.type) === 'DVC.optIn.saved') {
                    _this.refetchConfig(false);
                }
            };
            window.addEventListener('message', this.windowMessageHandler);
        }
    }
    DVCClient.prototype.onClientInitialized = function (onInitialized) {
        var _this = this;
        if (onInitialized && typeof onInitialized === 'function') {
            this.onInitialized
                .then(function () { return onInitialized(null, _this); })
                .catch(function (err) { return onInitialized(err); });
            return;
        }
        return this.onInitialized;
    };
    DVCClient.prototype.variable = function (key, defaultValue) {
        var _a;
        var _b, _c, _d, _e;
        if (defaultValue === undefined || defaultValue === null) {
            throw new Error('Default value is a required param');
        }
        var defaultValueKey = typeof defaultValue === 'string' ? defaultValue : JSON.stringify(defaultValue);
        var variable;
        if (this.variableDefaultMap[key] && this.variableDefaultMap[key][defaultValueKey]) {
            variable = this.variableDefaultMap[key][defaultValueKey];
        }
        else {
            var data = __assign({ key: key, defaultValue: defaultValue }, (_c = (_b = this.config) === null || _b === void 0 ? void 0 : _b.variables) === null || _c === void 0 ? void 0 : _c[key]);
            variable = new Variable_1.DVCVariable(data);
            this.variableDefaultMap[key] = __assign((_a = {}, _a[defaultValueKey] = variable, _a), this.variableDefaultMap[key]);
        }
        try {
            var variableFromConfig = (_e = (_d = this.config) === null || _d === void 0 ? void 0 : _d.variables) === null || _e === void 0 ? void 0 : _e[key];
            this.eventQueue.queueAggregateEvent({
                type: variable.isDefaulted
                    ? EventQueue_1.EventTypes.variableDefaulted
                    : EventQueue_1.EventTypes.variableEvaluated,
                target: variable.key,
                metaData: {
                    value: variable.value,
                    type: getTypeFromDefaultValue(variable.defaultValue, variable.key, this.logger),
                    _variable: variableFromConfig === null || variableFromConfig === void 0 ? void 0 : variableFromConfig._id
                }
            });
        }
        catch (e) {
            this.eventEmitter.emitError(e);
            this.logger.error("Error with queueing aggregate events ".concat(e));
        }
        return variable;
    };
    DVCClient.prototype.identifyUser = function (user, callback) {
        var _this = this;
        var promise = new Promise(function (resolve, reject) {
            _this.eventQueue.flushEvents();
            var updatedUser;
            if (user.user_id === _this.user.user_id) {
                updatedUser = _this.user.updateUser(user, _this.options);
            }
            else {
                updatedUser = new User_1.DVCPopulatedUser(user, _this.options);
            }
            _this.onInitialized.then(function () {
                return _this.requestConsolidator.queue(updatedUser);
            }).then(function (config) {
                resolve(config.variables || {});
            }).catch(function (err) {
                _this.eventEmitter.emitError(err);
                reject(err);
            });
        });
        if (callback && typeof callback == 'function') {
            promise.then(function (variables) { return callback(null, variables); })
                .catch(function (err) { return callback(err, null); });
            return;
        }
        return promise;
    };
    DVCClient.prototype.resetUser = function (callback) {
        var _this = this;
        var anonUser = new User_1.DVCPopulatedUser({ isAnonymous: true }, this.options);
        var promise = new Promise(function (resolve, reject) {
            _this.eventQueue.flushEvents();
            _this.onInitialized.then(function () { return _this.requestConsolidator.queue(anonUser); })
                .then(function (config) {
                resolve(config.variables || {});
            }).catch(function (e) {
                _this.eventEmitter.emitError(e);
                reject(e);
            });
        });
        if (callback && typeof callback == 'function') {
            promise.then(function (variables) { return callback(null, variables); })
                .catch(function (err) { return callback(err, null); });
            return;
        }
        return promise;
    };
    DVCClient.prototype.allFeatures = function () {
        var _a;
        return ((_a = this.config) === null || _a === void 0 ? void 0 : _a.features) || {};
    };
    DVCClient.prototype.allVariables = function () {
        var _a;
        return ((_a = this.config) === null || _a === void 0 ? void 0 : _a.variables) || {};
    };
    DVCClient.prototype.subscribe = function (key, handler) {
        this.eventEmitter.subscribe(key, handler);
    };
    DVCClient.prototype.unsubscribe = function (key, handler) {
        this.eventEmitter.unsubscribe(key, handler);
    };
    DVCClient.prototype.track = function (event) {
        var _this = this;
        if (this._closing) {
            this.logger.error('Client is closing, cannot track new events.');
            return;
        }
        (0, utils_1.checkParamDefined)('type', event.type);
        this.onInitialized.then(function () {
            _this.eventQueue.queueEvent(event);
        });
    };
    DVCClient.prototype.flushEvents = function (callback) {
        return this.eventQueue.flushEvents().then(function () { return callback === null || callback === void 0 ? void 0 : callback(); });
    };
    DVCClient.prototype.close = function () {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.logger.debug('Closing client');
                        this._closing = true;
                        if (document && this.pageVisibilityHandler) {
                            document.removeEventListener('visibilitychange', this.pageVisibilityHandler);
                        }
                        if (this.windowMessageHandler) {
                            window.removeEventListener('message', this.windowMessageHandler);
                        }
                        (_a = this.streamingConnection) === null || _a === void 0 ? void 0 : _a.close();
                        return [4 /*yield*/, this.eventQueue.close()];
                    case 1:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Object.defineProperty(DVCClient.prototype, "closing", {
        get: function () {
            return this._closing;
        },
        enumerable: false,
        configurable: true
    });
    DVCClient.prototype.refetchConfig = function (sse, lastModified) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.onInitialized];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.requestConsolidator.queue(null, { sse: sse, lastModified: lastModified })];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    DVCClient.prototype.handleConfigReceived = function (config, user) {
        var _this = this;
        var _a;
        var oldConfig = this.config;
        this.config = config;
        this.store.saveConfig(config).then(function () {
            _this.logger.info('Successfully saved config to local storage');
        });
        if (this.user != user || !this.userSaved) {
            this.user = user;
            this.store.saveUser(user).then(function () {
                _this.logger.info('Successfully saved user to local storage');
            });
            if (!this.user.isAnonymous && checkIfEdgeEnabled(config, this.logger, (_a = this.options) === null || _a === void 0 ? void 0 : _a.enableEdgeDB, true)) {
                (0, Request_1.saveEntity)(this.user, this.environmentKey, this.logger, this.options)
                    .then(function (res) { return _this.logger.info("Saved response entity! ".concat(res)); });
            }
            this.userSaved = true;
        }
        var oldFeatures = (oldConfig === null || oldConfig === void 0 ? void 0 : oldConfig.features) || {};
        var oldVariables = (oldConfig === null || oldConfig === void 0 ? void 0 : oldConfig.variables) || {};
        this.eventEmitter.emitFeatureUpdates(oldFeatures, config.features);
        this.eventEmitter.emitVariableUpdates(oldVariables, config.variables, this.variableDefaultMap);
    };
    DVCClient.prototype.onSSEMessage = function (message) {
        var _this = this;
        var _a, _b;
        try {
            var parsedMessage = JSON.parse(message);
            var messageData = JSON.parse(parsedMessage.data);
            if (!messageData) {
                return;
            }
            if (!messageData.type || messageData.type === 'refetchConfig') {
                if (!((_a = this.config) === null || _a === void 0 ? void 0 : _a.etag) || messageData.etag !== ((_b = this.config) === null || _b === void 0 ? void 0 : _b.etag)) {
                    this.refetchConfig(true, messageData.lastModified).catch(function (e) {
                        _this.logger.error('Failed to refetch config', e);
                    });
                }
            }
        }
        catch (e) {
            this.logger.error('Streaming Connection: Unparseable message', e);
        }
    };
    DVCClient.prototype.registerVisibilityChangeHandler = function () {
        var _this = this;
        var _a, _b, _c;
        if (typeof document === 'undefined') {
            return;
        }
        var inactivityDelay = ((_b = (_a = this.config) === null || _a === void 0 ? void 0 : _a.sse) === null || _b === void 0 ? void 0 : _b.inactivityDelay) || 120000;
        this.pageVisibilityHandler = function () {
            var _a, _b, _c;
            if (!((_a = _this.config) === null || _a === void 0 ? void 0 : _a.sse)) {
                return;
            }
            else if (document.visibilityState === 'visible') {
                if (!((_b = _this.streamingConnection) === null || _b === void 0 ? void 0 : _b.isConnected())) {
                    _this.logger.debug('Page became visible, refetching config');
                    _this.refetchConfig(false).catch(function (e) {
                        _this.logger.error('Failed to refetch config', e);
                    });
                    (_c = _this.streamingConnection) === null || _c === void 0 ? void 0 : _c.reopen();
                }
                window === null || window === void 0 ? void 0 : window.clearTimeout(_this.inactivityHandlerId);
            }
            else {
                window === null || window === void 0 ? void 0 : window.clearTimeout(_this.inactivityHandlerId);
                _this.inactivityHandlerId = window === null || window === void 0 ? void 0 : window.setTimeout(function () {
                    var _a;
                    _this.logger.debug('Page is not visible, closing streaming connection');
                    (_a = _this.streamingConnection) === null || _a === void 0 ? void 0 : _a.close();
                }, inactivityDelay);
            }
        };
        (_c = document.addEventListener) === null || _c === void 0 ? void 0 : _c.call(document, 'visibilitychange', this.pageVisibilityHandler);
    };
    return DVCClient;
}());
exports.DVCClient = DVCClient;
var checkIfEdgeEnabled = function (config, logger, enableEdgeDB, logWarning) {
    var _a, _b;
    if (logWarning === void 0) { logWarning = false; }
    if ((_b = (_a = config.project.settings) === null || _a === void 0 ? void 0 : _a.edgeDB) === null || _b === void 0 ? void 0 : _b.enabled) {
        return !!enableEdgeDB;
    }
    else {
        if (enableEdgeDB && logWarning) {
            logger.warn('EdgeDB is not enabled for this project. Only using local user data.');
        }
        return false;
    }
};
var getTypeFromDefaultValue = function (defaultValue, key, logger) {
    if (typeof defaultValue === 'boolean') {
        return types_1.VariableType.boolean;
    }
    else if (typeof defaultValue === 'number') {
        return types_1.VariableType.number;
    }
    else if (typeof defaultValue === 'string') {
        return types_1.VariableType.string;
    }
    else if (typeof defaultValue === 'object') {
        return types_1.VariableType.object;
    }
    else {
        logger.warn("The default value for variable ".concat(key, " is not of type Boolean, Number, String, or JSON"));
        return undefined;
    }
};
var stubbedLocalStorage = {
    getItem: function () { return null; },
    setItem: function () { return undefined; },
    removeItem: function () { return undefined; },
    clear: function () { return undefined; },
    key: function () { return null; },
    length: 0
};
//# sourceMappingURL=Client.js.map