import { DVCClient } from './Client';
import { DVCEvent } from './types';
export declare const EventTypes: {
    variableEvaluated: string;
    variableDefaulted: string;
};
declare type AggregateEvent = DVCEvent & {
    target: string;
};
export declare class EventQueue {
    private readonly environmentKey;
    client: DVCClient;
    eventQueue: DVCEvent[];
    aggregateEventMap: Record<string, Record<string, AggregateEvent>>;
    eventFlushIntervalMS: number;
    flushInterval: ReturnType<typeof setInterval>;
    constructor(environmentKey: string, dvcClient: DVCClient, eventFlushIntervalMS?: number);
    flushEvents(): Promise<void>;
    /**
     * Queue DVCAPIEvent for producing
     */
    queueEvent(event: DVCEvent): void;
    /**
     * Queue DVCEvent that can be aggregated together, where multiple calls are aggregated
     * by incrementing the 'value' field.
     */
    queueAggregateEvent(event: AggregateEvent): void;
    /**
     * Turn the Aggregate Event Map into an Array of DVCAPIEvent objects for publishing.
     */
    private eventsFromAggregateEventMap;
    close(): Promise<void>;
}
export {};
